/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.h
  * @brief          : Header for main.c file.
  *                   This file contains the common defines of the application.
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2019 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "stm32f1xx_hal.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include <stdio.h>
#include <stdbool.h>
#include <string.h>
#include "uart.h"
#include "CRC16.h"
#include "flash.h"
#include "esp8266.h"
/* USER CODE END Includes */

/* Exported types ------------------------------------------------------------*/
/* USER CODE BEGIN ET */

/* USER CODE END ET */

/* Exported constants --------------------------------------------------------*/
/* USER CODE BEGIN EC */

/* USER CODE END EC */

/* Exported macro ------------------------------------------------------------*/
/* USER CODE BEGIN EM */

/* USER CODE END EM */

/* Exported functions prototypes ---------------------------------------------*/
void Error_Handler(void);

/* USER CODE BEGIN EFP */

/* USER CODE END EFP */

/* Private defines -----------------------------------------------------------*/
#define BOOT_LED_Pin GPIO_PIN_15
#define BOOT_LED_GPIO_Port GPIOC
#define DET_OUT_B_Pin GPIO_PIN_0
#define DET_OUT_B_GPIO_Port GPIOC
#define EXT_DET_B_Pin GPIO_PIN_1
#define EXT_DET_B_GPIO_Port GPIOC
#define LED_UL_G_B_Pin GPIO_PIN_1
#define LED_UL_G_B_GPIO_Port GPIOA
#define LED_SD_R_B_Pin GPIO_PIN_4
#define LED_SD_R_B_GPIO_Port GPIOA
#define PWR_LED_B_Pin GPIO_PIN_5
#define PWR_LED_B_GPIO_Port GPIOA
#define LED_DL_G_B_Pin GPIO_PIN_6
#define LED_DL_G_B_GPIO_Port GPIOA
#define LED_DL_R_B_Pin GPIO_PIN_7
#define LED_DL_R_B_GPIO_Port GPIOA
#define RFU_TEMP_Pin GPIO_PIN_1
#define RFU_TEMP_GPIO_Port GPIOB
#define RST_WIFI_B_Pin GPIO_PIN_15
#define RST_WIFI_B_GPIO_Port GPIOB
#define PLL_LD_B_Pin GPIO_PIN_6
#define PLL_LD_B_GPIO_Port GPIOC
#define ATT_DATA_B_Pin GPIO_PIN_13
#define ATT_DATA_B_GPIO_Port GPIOA
#define ATT_EN1_B_Pin GPIO_PIN_14
#define ATT_EN1_B_GPIO_Port GPIOA
#define ATT_EN2_B_Pin GPIO_PIN_15
#define ATT_EN2_B_GPIO_Port GPIOA
#define PLL_EN_B_Pin GPIO_PIN_12
#define PLL_EN_B_GPIO_Port GPIOC
#define ATT_CLK_B_Pin GPIO_PIN_2
#define ATT_CLK_B_GPIO_Port GPIOD
#define PA_EN_B_Pin GPIO_PIN_3
#define PA_EN_B_GPIO_Port GPIOB
#define EXT_PA_EN_B_Pin GPIO_PIN_4
#define EXT_PA_EN_B_GPIO_Port GPIOB
#define PLL_CLK_B_Pin GPIO_PIN_6
#define PLL_CLK_B_GPIO_Port GPIOB
#define PLL_DATA_B_Pin GPIO_PIN_7
#define PLL_DATA_B_GPIO_Port GPIOB
/* USER CODE BEGIN Private defines */
#define ADC_EA     14
uint32_t ADCvalue[ADC_EA];
/* USER CODE END Private defines */

#ifdef __cplusplus
}
#endif

#endif /* __MAIN_H */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
